
# This script is a 'explain a word' script

# To allow someone add a word, type in console
# .chattr handle +Z 

# bind pub - "!explain" dict:explain
# bind pub - "!addword" dict:addword
# bind pub - "!delword" dict:delword
# bind pubm - "*" dict:scanforwords

# Set this to the dictionary file
set dictfile "dictionary"

# Here shall the code start

proc dict:listtostring {list belem selem} {
    set ret [lrange $list $belem $selem]
    set ret [string trim $ret "{"]
    set ret [string trim $ret "}"]
    return $ret
}

proc dict:scanforwords {nick idx handle channel args} {
    global dictfile
    foreach word $args {
	set reffile [open $dictfile r]
	while {![eof $reffile]} {
	    gets $reffile refword
	    set refexpl [lindex [split $refword "="] 1]
	    set refword [lindex [split $refword "="] 0]
	    if {([regexp -nocase "$refword" "$word"])&&([string tolower $word]!=$nick)&&([rand 100]>70)&&($refword!="")} {
		puthelp "PRIVMSG $channel :$nick, $refword: $refexpl"
		close $reffile
		return 0
	    }
	}
	close $reffile
    }
    return 0
}

proc dict:explain {nick idx handle channel args} {
    global dictfile
    if {![file exist $dictfile]} { 
	set dfile [open $dictfile w]
	puts -nonewline $dfile ""
	close $dfile
    }
    set word [dict:listtostring $args 0 end]
    set dfile [open $dictfile r]
    set dline ""
    while {![eof $dfile]} {
	gets $dfile dline
	set dline [split $dline "="]
	set dword [lindex $dline 0]
	set dexpl [lindex $dline 1]
	set word [string tolower $word]
	if {$dword==$word} {
	    puthelp "PRIVMSG $channel :$word: $dexpl"
	    close $dfile
	    return 0
	}
    }
    close $dfile
    puthelp "PRIVMSG $channel :$word not found"
    return 0
}

proc dict:addword {nick idx handle channel args} {
    global dictfile
    if {![matchattr $handle "Z"]} {
	puthelp "NOTICE $nick :Go depress someone else"
	return 0
    }
    if {![file exist $dictfile]} {
	set dfile [open $dictfile w]
	puts -nonewline $dfile ""
	close $dfile
    }
    set args [dict:listtostring $args 0 end]
    set args [split $args "="]
    set word [lindex $args 0]
    set expl [lindex $args 1]
    set word [string tolower $word]
    set dfile [open $dictfile r]
    if {($word=="")||($expl=="")} {
        puthelp "NOTICE $nick :Not enough parameters"
        puthelp "NOTICE $nick :word=explanation"
        return 0
    }
    while {![eof $dfile]} {
	gets $dfile dline
	set vword [lindex [split $dline "="] 0]
	if {$vword==$word} {
	    puthelp "NOTICE $nick :Word already in database"
	    puthelp "NOTICE $nick :$dline"
	    close $dfile
	    return 0
	}
    }
    close $dfile
    set dfile [open $dictfile a]
    puts $dfile "$word=$expl"
    close $dfile
    puthelp "NOTICE $nick :Word added"
}

proc dict:delword {nick idx handle channel args} {
    global dictfile
    if {![matchattr $handle "Z"]} {
	puthelp "NOTICE $nick :Go depress someone else"
	return 0
    }
    if {![file exist $dictfile]} { 
	set dfile [open $dictfile w]
	puts -nonewline $dfile ""
	close $dfile
    }
    set word [dict:listtostring $args 0 end]
    set dfile [open $dictfile r]
    set dline ""
    while {![eof $dfile]} {
	gets $dfile dline1
	set dline [split $dline1 "="]
	set dword [lindex $dline 0]
	set dexpl [lindex $dline 1]
	set word [string tolower $word]
	if {$dword!=$word} {
		lappend datalist $dline1
		puthelp "NOTICE $nick :Deleted!"
	}
    }
    close $dfile
    set file [open $dictfile w]
    foreach line $datalist {
	if {$line!=""} {puts $file $line}
    }
    close $file
}

proc dict:modword {nick idx handle channel args} {
    global dictfile
    if {![matchattr $handle "Z"]} {
	puthelp "NOTICE $nick :Go depress someone else"
	return 0
    }
    if {![file exist $dictfile]} { 
	set dfile [open $dictfile w]
	puts -nonewline $dfile ""
	close $dfile
    }
    set args [dict:listtostring $args 0 end]
    set args [split $args "="]
    set word [lindex $args 0]
    set expl [lindex $args 1]
    set word [string tolower $word]
    set dfile [open $dictfile r]
    if {($word=="")||($expl=="")} {
        puthelp "NOTICE $nick :Not enough parameters"
        puthelp "NOTICE $nick :word=explanation"
        return 0
    }
    set dfile [open $dictfile r]
    set dline ""
    while {![eof $dfile]} {
	gets $dfile dline1
	set dline [split $dline1 "="]
	set dword [lindex $dline 0]
	set dexpl [lindex $dline 1]
	set word [string tolower $word]
	if {$dword!=$word} {
		lappend datalist $dline1
	} else {
		lappend datalist "$word=$expl"
		puthelp "NOTICE $nick :Modified"
	}
    }
    close $dfile
    set file [open $dictfile w]
    foreach line $datalist {
	if {$line!=""} {puts $file $line}
    }
    close $file
}
