# Channel command kit

# If you encounter any problems(not the actions section) please mail
# your question and as much details of problem as possible to
# cmouse@fiiu.org - Please attach also any description of the situation
# or command where this happened. Also attach your user flags with it.
# It is the mode string you get when you type .whois
# example
#  .whois cmouse
# [16:41] #cmouse# whois cmouse
# HANDLE    PASS NOTES FLAGS           LAST
# cmouse    yes      0 fhjmnoptxZ      15:56 (partyline )
# #teddybears        fmno            15:48

# We need a script to use as a talking scrip
# if ya have none... then I suggest you use this one
# Put here your own OTHER scripts for use

# GREETS TO THE MAKER OF THE AI-LIVINGBOT SCRIPT

source scripts/ai-livingbot.3.tcl
source scripts/sanakirja.tcl

# Unbinds seen. Script has this command
# <prefix> seen.

unbind pub - "seen" *pub:seen

# Wordkick -list
# WORKS only with the command prefix(does not scan channel overall text)
set badwordlist "badwords"

# Command prefix - I recommend that you use a name here
# Change the nick and decomment(remove the #)
bind pubm -|- "% CodeM*" cmd:switch

# Allow this to use * Botnick did something from dcc chat
bind dcc -|o "action" dcc:action

# Authentication
bind msg -|- "auth" cmd:auth

# Deauthentication
bind part -|- "*" cmd:deauth
bind sign -|- "*" cmd:deauth
bind kick -|- "*" cmd:deauth

# Allow unknown users
set cmdallow 1

# Require authentication for admin commands
set cmdauth 1




# The code begins here - No need to look below

# For TCL programmers who wish to add stuff I have added some info.
# Channel commands go to the FIRST switch in cmd:switch
# User commands go to the proc cmd:usermanager
# Other commands go to the SECOND switch in cmd:switch
# You can use your own scripts. Make sure you don't
# have any binds in the script enabled(unless you want
# to have double access to commands). 

# HERE IS A LIST OF THE PROC'S IN THIS SCRIPT AND THEIR PARAMETERS


# cmd:auth nick idx handle args           - sets XTRA AUTH YES on success
# cmd:deauth nick idx handle channel args - sets XTRA AUTH NO on success
# cmd:checkauth handle                    - returns 1 on success, 0 on failure
# cmd:switch nick idx handle channel args
# cmd:help section channel nick
# cmd:manager command parameters channel nick handle
# cmd:chanmodes command target reason channel handle nick
# cmd:kickass target reason channel handle nick
# cmd:give who what where
# cmd:ison nick                           - returns 1 on success, 0 on failure
# cmd:imhere nick channel
# cmd:nick2hand nick channel
# cmd:makehandle handle
# dcc:action handle idx args
# cmd:doaction command victim channel nick - returns 1 on success, 0 if not
# putaction action channel - puts a /me command to channel
# cmd:getlost nick


# The authentication functions
proc cmd:auth {nick idx handle args} {

    # It's just bummer if the user has no password
    # any password is valid on that case, let's take
    # care of that, shall we.
    if {$handle=="*"} {
	puthelp "NOTICE $nick :Who the hell are you?!?"
	putcmdlog "ERROR!! $nick tried to auth, though unknown!"
	return 0
    }
    if {[passwdok $handle ""]} {
	puthelp "NOTICE $nick :Failed - please set your password" 
	putcmdlog "ERROR!! $handle\[$nick\] has no password"
	return 0
    }
  if {![passwdok $handle $args]} {
   puthelp "NOTICE $nick :Failed - check your password"
   putcmdlog "ERROR!! $handle\[$nick\] used incorrect password!"
   return 0
 }

 # Set XTRA info on user
 # As it's not on USERINFO.TCL this is
 # not changeable unless you have 
 # tcl command bound

 setuser $handle XTRA "AUTH" "YES"
 putcmdlog "$handle\[$nick\] authed"
 puthelp "NOTICE $nick :Authed"
}

# Deauthenticating user as he does something

proc cmd:deauth {nick idx handle channel args} {
    if {$handle=="*"} {return 0}
    if {![cmd:ison $nick $channel]} {
	setuser $handle XTRA "AUTH" "NO"
	putcmdlog "$handle\[$nick\] deauthed"
    }
}

proc cmd:checkauth {handle} {
 if {[getuser $handle XTRA "AUTH"]=="YES"} {
  return 1
 } else {
  return 0
 }
}

# Makes a list turn to a string, it must be magic...
proc cmd:listtostring {list belem selem} { 
 set ret [lrange $list $belem $selem]
 return "$ret"
}

# The main "switching" program. Selects the suitable
# sub program according to user parameters.

proc cmd:switch {nick idx handle channel cmdstr} {
 global cmdallow cmdauth
 set iglist {matilda viagra}
 if {[lsearch $iglist [string tolower $nick]]>-1} { return 0 }
 set cmdstr [lrange $cmdstr 1 end]
 if {[llength $cmdstr] == 0} {
     cmd:imhere $nick $channel
     return 0
 }
 if {$cmdallow == 0} {
  if {$handle == "*"} {
   do_8ball_chan $nick $idx $handle $channel $cmdstr
   return 0
  }
 }
 set argn 0
 set args(1) ""
 set args(2) ""
 set aargs {}
 foreach arg $cmdstr {
  incr argn
  set args($argn) [string tolower $arg]
 }

# This is needed to monitor successfull command

set success 0

# Channel modes and actions, standard stuff. More or less self describing...
# Please notice the -glob parameter that allows us to use * prefix

 switch -glob $args(1) {
  "help" {
   cmd:help $args(2) $channel $nick
   set success 1
  }
  "*op" {
   cmd:chanmodes $args(1) $args(2) "reason" $channel $handle $nick
   set success 1
  }
  "opme" {
   cmd:chanmodes $args(1) $nick "reason" $channel $handle $nick
   set success 1
  }
  "*voice" {
   cmd:chanmodes $args(1) $args(2) "reason" $channel $handle $nick
   set success 1
  }
  "*ban" {
   cmd:chanmodes $args(1) $args(2) [cmd:listtostring $cmdstr 2 end] $channel $handle $nick
   set success 1
  }
  "topic" {
   cmd:chanmodes $args(1) $nick [cmd:listtostring $cmdstr 1 end] $channel $handle $nick
   set success 1
  }
  "kick" {
   cmd:kickass $args(2) [cmd:listtostring $cmdstr 2 end] $channel $handle $nick
   set success 1
  }
  "kickban" {
   cmd:chanmodes $args(1) $args(2) [cmd:listtostring $cmdstr 2 end] $channel $handle $nick
   set success 1
  }
  "seen" {
   *pub:seen $nick $idx $handle $channel $args(2)
   set success 1
  }
  "set" {
   cmd:chanmodes $args(1) $args(2) [cmd:listtostring $cmdstr 2 end] $channel $handle $nick
   set success 1
  }
}

# and here we check the rest. I just want to make a line between channel
# admin and channel toy commands. Again notice the -glob.

switch -glob $args(1) {
    "give" {
	cmd:give $args(2) [cmd:listtostring $cmdstr 2 end] $channel
	set success 1
    }
    "quote" {
	*pub:showquote $nick $idx $handle $channel $args(2)
	set success 1
    }
    "user" {
	cmd:manager $args(2) [cmd:listtostring $cmdstr 2 end] $channel $nick $handle
	set success 1
    }
    "whois" {
	if {[nick2hand $args(2) $channel]=="*"} {puthelp "NOTICE $nick :I don't know $args(2)" } else { puthelp "NOTICE $nick :$args(2) is known to me as [nick2hand $args(2) $channel]" }
	set success 1
    }
    "explain" {
	dict:explain $nick $idx $handle $channel [cmd:listtostring $cmdstr 1 end]
	set success 1
    }
    "learn" {
	dict:addword $nick $idx $handle $channel [lrange $cmdstr 1 end]
	set success 1
    }
    "forget" {
	dict:delword $nick $idx $handle $channel [cmd:listtostring $cmdstr 1 end]
	set success 1
    }
    "relearn" {
	dict:modword $nick $idx $handle $channel [cmd:listtostring $cmdstr 1 end]
	set success 1
    }
}

if {$success==0} { set success [cmd:doaction $args(1) [cmd:listtostring $cmdstr 1 end] $channel $nick] }

if {$success==0} { 
    if {[checkbadparams $cmdstr $nick $channel]==1} { return 0 }
     do_8ball_chan $nick $idx $handle $channel $cmdstr 
     return 0
 } else {
     return 0
 }
}

# Help section - It is dependand to your modes what you will be able to see
# also you must ask the propriate section. 
# Sections are channel, user and other

proc cmd:help {section channel nick} {
    global botnick
    set handle [nick2hand $nick $channel] 
    puthelp "NOTICE $nick :Toolscript v1.0 help"
    set master 0
    set op 0
    if {([matchattr $handle "m"])||([matchattr $handle "|m" $channel])} { set master 1 } 
    if {([matchattr $handle "o"])||([matchattr $handle "|o" $channel])} { set op 1 }
    if {$section==""} {
	puthelp "NOTICE $nick :You can use the following sections of this script"
	if {$master} { puthelp "NOTICE $nick :user - user list manipulation commands" }
	if {$op} { puthelp "NOTICE $nick :channel - channel commands" }
	puthelp "NOTICE $nick :misc - miscellancelous commands"
	puthelp "NOTICE $nick :Type $botnick help <section> to get commands for specific section"
	puthelp "NOTICE $nick :All commands starts with $botnick"
	return 0
    }
    set section [string tolower $section]
    if {($section=="channel")&&(($master)||($op))} {
	puthelp "NOTICE $nick :Channel commands"
	puthelp "NOTICE $nick :op <nick> - give nick channel operator status"
	puthelp "NOTICE $nick :opme - gives you ops(if you can have them)"
	puthelp "NOTICE $nick :deop <nick> - removes operator status from nick"
	puthelp "NOTICE $nick :voice <nick> - gives +v to nick(useful only if +m set for channel"
	puthelp "NOTICE $nick :devoice <nick> - removes +v from nick"
	puthelp "NOTICE $nick :kick <nick> <reason> - kicks nick from channel"
	puthelp "NOTICE $nick :ban <hostmask> <reason> - adds a ban to channel"
	puthelp "NOTICE $nick :unban <hostmask> - removes a existing ban"
	puthelp "NOTICE $nick :listban - lists all bans"
	puthelp "NOTICE $nick :topic <topic> - sets channel topic"
	return 0
    }
    if {($section=="user")&&($master)} {
	puthelp "NOTICE $nick :Userlist handling commands - The script will"
	puthelp "NOTICE $nick :attempt to change nicks to handle"
	puthelp "NOTICE $nick :<nick> add (as <handle/bot>) - adds a user"
	puthelp "NOTICE $nick :    The as part is due the fact that some people"
	puthelp "NOTICE $nick :    want to give someone a specific handle"
	puthelp "NOTICE $nick :    Using the bot tells to add the thing as"
	puthelp "NOTICE $nick :    a bot."
	puthelp "NOTICE $nick :<handle> delete - deletes user"
	puthelp "NOTICE $nick :<handle> info - shows you information on user"
	puthelp "NOTICE $nick :<handle> modes <modestring> (channel)- sets users modes"
	puthelp "NOTICE $nick :<handle> addhost <hostmask> - Adds a hostmask to user"
	puthelp "NOTICE $nick :<handle> delhost <hostmask> - Deletes a hostmask from user"
	puthelp "NOTICE $nick :<handle> hostlist - Lists users hosts"
	puthelp "NOTICE $nick :list - Lists some users"
	return 0
    }
    if {$section=="misc"} {
	puthelp "NOTICE $nick :Miscellancelous commands"
	puthelp "NOTICE $nick :give <nick> <item> - Offers item to nick"
	puthelp "NOTICE $nick :whois <nick> - Shows nick's handle(if has one)"
	puthelp "NOTICE $nick :explain word - Tries to explain a word from it's dictionary"
	puthelp "NOTICE $nick :learn word=explanation - dictionary(need +Z)"
	puthelp "NOTICE $nick :forget word - dictionary(need +Z)"
	puthelp "NOTICE $nick :relearn word=explanation - dictionary(need +Z)"
	puthelp "NOTICE $nick :spank, kiss, kill, etc. <nick> - Actions to be done on nick"
	return 0
    }
    puthelp "NOTICE $nick :No such topic!"
}

# User manager - command target handle/bot $modes $channel

proc cmd:manager {command params channel nick handle} {
    if {$handle=="*"} {
	putcmdlog "SECURITY VIOLATION!!! $nick tried to use user $command!!!"
	puthelp "NOTICE $nick :Security violation detected, access denied"
	return 0
    }
    global cmdauth botnick
    # We must recreate the $args(n) structure here
    set args(1) ""
    set args(2) ""
    set args(3) ""
    set args(4) ""
    set paramn 1
    foreach param $params {
	incr paramn
	set args($paramn) $param
    }
    set args(1) $args(2)
    set args(2) $command
    set command $args(1)
    if {[string tolower $args(1)]=="codem"} {
	putserv "NOTICE $nick :I don't want to use myself..."
	return 0
    }
    if {$cmdauth==1} {
	if {![cmd:checkauth $handle]} {
	    putserv "NOTICE $nick :You have not authed!"
	    return 0
	}
    }
    if {!([matchattr $handle "m"] || [matchattr $handle "|m" $channel])} {
	putcmdlog "SECURITY VIOLATION!!! $nick\[$handle\] tried to exceed rights!!!"
	putserv "NOTICE $nick :You can't do this!"
	return 0
    }
    set tnick $args(2)
    set target [cmd:nick2hand $args(2) $channel]
    putcmdlog "($nick/$handle): $command\[$channel\] $tnick/$target"
    if {(($target=="")||($target=="*"))&&(($command!="add")&&($command!="list"))} { 
	puthelp "NOTICE $nick :I don't know any $tnick" 
	return 0
    }
    if {$paramn<3} { 
	set args(4) ""
    }
    switch -exact $command {
	"add" {
	    if {$target!="*"} { 
		puthelp "NOTICE $nick :$tnick is on bot database as $target" 
		return 0
	    } else {
		set target ""
	    }
	    if {($args(4)!="bot")&&($args(4)!="")} {set target $args(4)}
	    if {$target==""} { set target [cmd:makehandle $tnick] }
	    if {$args(4)!="bot"} { 
		adduser $target "[maskhost [getchanhost $tnick $channel]]"
		puthelp "NOTICE $nick :User $target added"
		puthelp "NOTICE $tnick :You have been added to $botnick"
	    } else {
		set target [cmd:makehandle $tnick]
		addbot $target "set.this.com:3333"
		setuser $target hosts "$tnick![getchanhost $tnick $channel]"
		puthelp "NOTICE $nick :Bot $target added"
	    }
	}
	"delete" {
	    deluser $target
	    puthelp "NOTICE $nick :User $target has been removed"
	}
	"modes" {
	    if {$args(4)!=""} { set args(3) "|$args(3)" }
	    if {($args(4)=="")&&([matchattr $handle "m"])} {
		chattr $target $args(3)
		puthelp "NOTICE $nick :User $target modes"
		puthelp "NOTICE $nick :-- Global modes: [chattr $target]"
	    } else {
		if {$args(4)==""} { puthelp "NOTICE $nick :You can't do this" } else {
		    if {![matchattr $handle "m"]} { set args(4) $channel }
		    chattr $target $args(3) $args(4)
		    puthelp "NOTICE $nick :User $target modes"
		    puthelp "NOTICE $nick :-- Global modes: [chattr $target]"
		    if {$args(4)!=""} { puthelp "NOTICE $nick :-- $args(4) modes: [lindex [split [chattr $target $args(4)] "|"] 1]" }
		}	    
	    }
	}
	"addhost" {
	    set hostlist [getuser $target hosts]
            if {[lsearch -exact $hostlist $args(3)]>-1} {
                puthelp "NOTICE $nick :Host $args(3) for user $target exists"
                puthelp "NOTICE $nick :Use another hostmask"
                return 0
            }
            setuser $target hosts $args(3)
	    puthelp "NOTICE $nick :Added $args(3) to $target"
	}
        "delhost" {
            set hostlist [getuser $target hosts]
            if {[lsearch -exact $hostlist $args(3)]==-1} {
                puthelp "NOTICE $nick :Host $args(3) for user $target is invalid"
                puthelp "NOTICE $nick :Use some other host"
                return 0
            }
            delhost $target $args(3)
	    puthelp "NOTICE $nick :Host $args(3) deleted from $target"
        }
        "hostlist" {
            set hostlist [getuser $target hosts]
            puthelp "NOTICE $nick :Host listing for $target"
            foreach host $hostlist {
                puthelp "NOTICE $nick :$host"
            }
            puthelp "NOTICE $nick :--End of list--"
        }
	"list" {
	    set users [userlist $channel]
	    puthelp "NOTICE $nick :User list for $channel ([llength $users] users)"
	    foreach user $users {
		set chanowner 0
		set chanmaster 0
		set chanop 0
		set chanmodes [chattr $user $channel]
		set chamodes [lindex [split $chanmodes "|"] 1]
		if {[string match "*n*" $chanmodes]} { set chanowner 1 }
		if {[string match "*m*" $chanmodes]} { set chanmaster 1 }
		if {[string match  "*o*" $chanmodes]} { set chanop 1 }
		if {$chanowner==1} { 
		    puthelp "NOTICE $nick :$user (is a channel owner)" 
		} else {
		    if {$chanmaster==1} {
			puthelp "NOTICE $nick :$user (is a channel master)"
		    } else {
			if {$chanop==1} {
			    puthelp "NOTICE $nick :$user (is a channel operator)"
			} else { puthelp "NOTICE $nick :$user" }
		    }
		}
	    }
	}
	"info" {
	    puthelp "NOTICE $nick :Info sheet for $target"
	    puthelp "NOTICE $nick :-- Global modes: [chattr $target]"
	    foreach ch [channels] {
		if {[lindex [split [chattr $target $ch] "|"] 1]!="-"} {
		    puthelp "NOTICE $nick :-- $ch modes: [lindex [split [chattr $target $ch] "|"] 1]"
	    
		}
	    }
	    puthelp "NOTICE $nick :(hostlist can be retrieved with hostlist command)"
	    if {[passwdok $target ""]} {
		puthelp "NOTICE $nick :-- Has no password"
	    } else {
		puthelp "NOTICE $nick :-- Has a password"
	    }
	    if {[cmd:checkauth $target]} { puthelp "NOTICE $nick :-- Is authed" } else { puthelp "NOTICE $nick :-- Is not authed" }
	}
    }
    return 0
}

# Different channel modes

proc cmd:chanmodes {command target reason channel handle nick} {
    if {$handle=="*"} {
	putcmdlog "SECURITY VIOLATION!!! $nick tried to use $command"
	puthelp "NOTICE $nick :Security violation detected, access denied"
	return 0
    }
 global cmdauth botnick
 # Check for auth
 if {$cmdauth==1} {
  if {![cmd:checkauth $handle]} {
   putserv "NOTICE $nick :You have not authed"
   return 0
  }
 }

 # May or may him not do this, currently it's enough to have channel o
 # for the channel or global m for all channels.

 if {!([matchattr $handle "o"] || [matchattr $handle "|o" $channel])} {
   putserv "NOTICE $nick :You can't do this!"
   putcmdlog "SECURITY VIOLATION!!! $nick\[$handle\] tried to overexceed rights on $channel"
   return 0
 }

 putcmdlog "($nick/$handle): $command\[$channel\] $target"

 # Okey, you can do this. But let's check did you supply proper name for action?
 if {[string tolower $target]==[string tolower $botnick]} {
     putserv "NOTICE $nick :I ain't gonna do it to my self!"
     putcmdlog "SECURITY VIOLATION!!! ($nick/$handle) TRIED TO USE $botnick AS TARGET ON $channel!!!"
      return 0
 }
 if {($command!="ban")&&($command!="unban")&&($command!="listban")} {
     if {!([onchan $target $channel]&&[lsearch $target [channels]]==-1)} {
	 set newtarget "[hand2nick $target $channel]"
	 if {$newtarget==""} {
	     putserv "NOTICE $nick :Unable to use $target"
	     return 0
	 } else {
	     set target $newtarget
	     putserv "NOTICE $nick :I suppose you mean $target."
	 }
	 if {[string tolower $target]=="codem"} {
	     putserv "NOTICE $nick :I aint gonna do it to my self"
	     return 0
	 }
     }
 }
 switch -exact -- $command {
   "op" {
    putserv "MODE $channel +o $target"
    puthelp "NOTICE $nick :Giving ops to $target"
   }
   "opme" {
    putserv "MODE $channel +o $target"
    puthelp "NOTICE $nick :Opping you"
   }
   "deop" {
    putserv "MODE $channel -o $target"
    puthelp "NOTICE $nick :Taking ops from $target"
   }
   "voice" {
    putserv "MODE $channel +v $target"
    puthelp "NOTICE $nick :Voicing $target"
   }
   "devoice" {
    putserv "MODE $channel -v $target"
    puthelp "NOTICE $nick :Devoicing $target"
   }
   "kickban" {
    set btarget "[maskhost [getchanhost $target $channel]]"
    newchanban $channel $btarget $handle $reason
    putserv "MODE $channel +b $btarget"
    putserv "KICK $channel $target :$reason"
   }
   "ban" {
    newchanban $channel $target $handle $reason
    puthelp "NOTICE $nick :Adding $target to $channel for $reason"
   }
   "listban" {
    set blist [banlist $channel]
    puthelp "NOTICE $nick :Ban list for $channel"
    puthelp "NOTICE $nick :---------------------"
    set bnro 0
    foreach banitem $blist {
	incr bnro
	set banitem [lindex [list $banitem] 0]
	set bhost "[lindex $banitem 0]"
	set breason [string trim "[lindex $banitem 1]" "{}"]
	if {$breason==""} { set breason "No reason" }
	set bissued "[ctime [lindex $banitem 2]]"
	if {[lindex $banitem 3]==0} {
	    set bexpire "permanent"
	} else {
	    set bexpire "[ctime [lindex $banitem 3]]"
	}
	set bissuer "[lindex $banitem 4]"
	puthelp "NOTICE $nick :Ack"
	puthelp "NOTICE $nick :\[$bnro\]Created $bissued"
	puthelp "NOTICE $nick :$bhost (expires $bexpire)"
	puthelp "NOTICE $nick :Reason: $breason"
    }
   }
   "unban" {
    killchanban $channel $target
    putserv "MODE $channel -b $target"
    puthelp "NOTICE $nick :Removing ban $target from $channel"
   }
   "topic" {
       if {$reason==""} { return 0 }
       putserv "TOPIC $channel :$reason"
   }
   "set" {
    putserv "MODE $target $reason"
   }
}
 return 0
}

# Kicks ass :)

proc cmd:kickass {target reason channel handle nick} {
  global cmdauth botnick
  if {$cmdauth==1} { if {![cmd:checkauth $handle]} {
    putserv "NOTICE $nick :You have not authed"
    return 0
   }
  }

 # Look above

 if {!([matchattr $handle "m"] || [matchattr $handle "|o" $channel])} {
   putserv "NOTICE $nick :You can't do this!"
   return 0
 }

 # Look above
 
 if {[string tolower $target]==[string tolower $botnick]} {
     putserv "NOTICE $nick :Kick yourself"
     putcmdlog "SECURITY VIOLATION!!! ($nick/$handle) TRIED TO KICK $botnick FROM $channel"
     return 0
 }
 putcmdlog "$handle\[$nick\] did a KICK on $target at $channel"
 if {!([onchan $target $channel]&&[lsearch $target [channels]]==-1)} {
   set newtarget "[hand2nick $target $channel]"
   if {$newtarget==""} {
	putserv "NOTICE $nick :Unable to use $target"
	return 0
   } else {
	set target $newtarget
	putserv "NOTICE $nick :I suppose you mean $target."
   }
}
 if {[string tolower $target]=="codem"} {
     putserv "NOTICE $nick :No thanks..."
     return 0
 }
 # Here we go...
 putserv "KICK $channel $target :$reason"
 return 0
}

proc cmd:give {who what where} {
    global botnick
    if {[string tolower $who]=="codem"} {
	putserv "PRIVMSG $where :I refuse to take it"
	return 0
    }
    if {[rand 10]<5} {
	putaction "hands $who $what." $where
    } else {
	putaction "offers $who $what." $where
    }
    return 0
}


proc cmd:ison {nick channel} {
    foreach chan [channels] {
	if {([string tolower $chan]!=[string tolower $channel])&&([onchan $nick $chan])} { return 1 }
    }
    return 0
}

proc cmd:imhere {nick channel} {
    putserv "PRIVMSG $channel :$nick: yep?"
    return 0
}

proc cmd:nick2hand {nick channel} {
    if {![validuser $nick]} { return [nick2hand $nick $channel] } else { return $nick }
}

proc cmd:makehandle {handle} {
    set target $handle
    if {[string length $target]>9} { set target [string range $target 0 9] }
    return $target
}

proc dcc:action {handle idx args} {
    set chan [lindex args 0]
    set act [cmd:listtostring $args 1 end]
    putaction $act $chan
    return 0
}

proc cmd:doaction {command victim channel nick} {

    if {[string tolower $victim]=="codem"} { 
	puthelp "PRIVMSG $channel :Yea right... Like I would be that stupid, $nick"
	return 1
    }

# Capable TCL scripters can add their own actions here
# Structure is 
# "word" {
#     commands
#     return 1
# }
# DO NOT FORGET TO SET RETURN 1 OR ELSE IT WILL WORK ODDLY!
# You can use putaction <actstring> $channel
# and $victim as the target nick.
# EXAMPLE putaction "does something to $victim" $channel
# RESULT: * CodeM * does something to cara"
# I will NOT help on this matter

    switch -exact $command {
	"burn" { 
	    putaction "takes flamethrower and torches $victim to ashes" $channel
	    puthelp "PRIVMSG $channel :Feeling a bit warm are we, $victim? Burn!"
	    return 1
	}
	"hit" { 
	    putaction "goes to $victim and pounders $victim to the floor" $channel 
	    return 1
	}
	"kiss" { 
	    putaction "slowly moves to $victim and kisses $victim gently on the neck" $channel 
	    return 1
	}
	"spank" { 
	    putaction "picks up her whip and spanks $victim for good" $channel 
	    return 1
	}
	"kill" { 
	    putaction "walks to $victim, takes a knife and slices $victim's throat with one fast swing." $channel 
	return 1
	}
	"kiitos" {
	    puthelp "PRIVMSG $channel :Your welcome, $nick"
	    return 1
	}
    }
    return 0
}

proc putaction {action channel} {
    puthelp "PRIVMSG $channel :\001ACTION $action"
    return 0
}

proc checkbadparams {par nick chan} {
    global badwordlist
    set parlist [split $par " "]
    set wlist [open $badwordlist] 
    while {![eof $wlist]} {
	gets $wlist bword
	if {[lsearch $parlist $bword]>-1} {
	    putserv "KICK $chan $nick :You flame me, I kick you!"
	    close $wlist
	    return 1
	}
    }
    close $wlist
    return 0
}

proc cmd:getlost {nick} {
  putserv "NOTICE $nick :Get lost!"
    return 0
}

